/* ===================================================================
 * ConvertRecipeSystemForm.java
 * 
 * Created Oct 14, 2004 8:43:36 AM
 * 
 * Copyright (c) 2004 Matt Magoffin (spamsqr@msqr.us)
 * 
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of 
 * the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 
 * 02111-1307 USA
 * ===================================================================
 * $Id: ConvertRecipeSystemForm.java 28 2009-05-04 01:19:45Z msqr $
 * ===================================================================
 */

package magoffin.matt.ieat.web;

import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import magoffin.matt.ieat.domain.Recipe;
import magoffin.matt.ieat.domain.System;
import magoffin.matt.ieat.domain.UiData;
import magoffin.matt.ieat.domain.UiSearchResults;
import magoffin.matt.ieat.util.RecipeCommand;

import org.springframework.validation.BindException;
import org.springframework.validation.Errors;
import org.springframework.web.servlet.ModelAndView;

/**
 * Form controller for converting a recipe to a different unit system.
 * 
 * @author Matt Magoffin (spamsqr@msqr.us)
 * @version $Revision: 28 $ $Date: 2009-05-04 13:19:45 +1200 (Mon, 04 May 2009) $
 */

public class ConvertRecipeSystemForm extends AbstractEatForm {

	@Override
	@SuppressWarnings("unchecked")
	protected Map referenceData(HttpServletRequest request, Object command,
			Errors errors) throws Exception {
		WebUtil.getBizContext(request,false);
		
		Map<String, Object> m = new LinkedHashMap<String, Object>();
		
		// add list of systems
		UiData ui = getDomainObjectFactory().getUiDataInstance();
		m.put("uidata",ui);
		List l = recipeBiz.getAvailableUnitSystems();
		ui.getSystem().addAll(l);
		
		// add recipe
		RecipeCommand recipeCommand = (RecipeCommand)command;
		Recipe r = recipeBiz.getRecipeById(recipeCommand.getRecipeId());
		ui.getRecipe().add(r);
		
		if ( recipeCommand.getIndex() != null || recipeCommand.getCriteria() != null ) {
			UiSearchResults sr = getDomainObjectFactory().getEmbeddedSearchResultsInstance();
			WebUtil.initSearchResults(sr,recipeCommand.getIndex(),recipeCommand.getCriteria(), getDomainObjectFactory());
			ui.setSearchResults(sr);
		}
		return m;
	}
	
	@SuppressWarnings("unchecked")
	@Override
	protected ModelAndView showForm(HttpServletRequest request,
			HttpServletResponse response, BindException errors, Map controlModel)
			throws Exception {
		List<System> l = recipeBiz.getAvailableUnitSystems();
		if ( l.size() == 2 ) {
			// get the system not used by the recipe and automatically select 
			// that, since there are only 2 choices and we can skip the choice form
			RecipeCommand recipeCommand = (RecipeCommand)errors.getTarget();
			Recipe r = recipeBiz.getRecipeById(recipeCommand.getRecipeId());
			System recipeSystem = r.getSystem();
			for ( System aSystem : l ) {
				if ( !aSystem.getSystemId().equals(recipeSystem.getSystemId()) ) {
					recipeCommand.setSystemId(aSystem.getSystemId());
					return onSubmit(request,response,recipeCommand,errors);
				}
			}
		}
		return super.showForm(request, response, errors, controlModel);
	}
	
	@Override
	@SuppressWarnings("unchecked")
	protected ModelAndView onSubmit(HttpServletRequest request,
			HttpServletResponse response, Object command, BindException errors)
			throws Exception {
		RecipeCommand recipeCommand = (RecipeCommand)command;
		Recipe converted = recipeBiz.convertRecipeSystem(
				recipeCommand.getRecipeId(),recipeCommand.getSystemId());
		Map<String, Object> model = errors.getModel();
		UiSearchResults sr = getDomainObjectFactory().getSearchResultsInstance();
		sr.getRecipe().add(converted);

		WebUtil.initSearchResults(sr,recipeCommand.getIndex(),recipeCommand.getCriteria(), getDomainObjectFactory());
		
		sr.setMode("converted");
		
		model.put(WebConstants.DEFALUT_MODEL_OBJECT,sr);
		ModelAndView result = new ModelAndView(getSuccessView(),model);
		return result;
	}

	@Override
	protected ModelAndView processCancel(HttpServletRequest request,
			HttpServletResponse response, Object command, BindException errors) {
		RecipeCommand recipeCommand = (RecipeCommand)command;
		Map<String, Object> model = new LinkedHashMap<String, Object>();
		WebUtil.saveRecipeCommand(model,recipeCommand);
		return new ModelAndView(getCancelView(),model);
	}

}
